package ca.recrown.islandsurvivalcraft.world.generation.alternation;

import java.util.Random;

import org.bukkit.World;
import org.bukkit.generator.ChunkGenerator;
import org.bukkit.plugin.java.JavaPlugin;

import ca.recrown.islandsurvivalcraft.world.generation.BiomeGenerator;
import ca.recrown.islandsurvivalcraft.world.generation.WorldGenerator;

public class AlternatingChunkGenerator extends ChunkGenerator {
    private final WorldGeneratorAlternator alternator;
    
    public AlternatingChunkGenerator(JavaPlugin plugin, BiomeGenerator biomeGenerator) {
        alternator = new WorldGeneratorAlternator(plugin, biomeGenerator);
    }

    @Override
    public ChunkData generateChunkData(World world, Random random, int chunkX, int chunkZ, BiomeGrid biome) {
        WorldGenerator worldGenerator = alternator.getGenerator(world, random);
        ChunkData chunk = createChunkData(world);

        for (int localX = 0; localX < 16; localX++) {
            for (int localZ = 0; localZ < 16; localZ++) {
                worldGenerator.GenerateChunk(chunkX, chunkZ, localX, localZ, chunk, biome);
            }
        }

        return chunk;
    }
}